View Issue Details

IDProjectCategoryView StatusLast Update
0006213CentOS-5nfs-utilspublic2013-04-18 20:02
ReporterAndreas Baumann Assigned To 
PrioritynormalSeveritymajorReproducibilityalways
Status assignedResolutionopen 
Product Version5.9 
Summary0006213: NFS mounts don't show all directory entries
Description'ls' on a NFS client shows only partial listings. The same directory looks ok
when doing an 'ls' on the NFS server.

I strongly suspect the NFSv4 readdir glitch at work as mentioned in:

http://www.spinics.net/lists/linux-nfs/msg19019.html

I get the same behaviour as mentioned in:

http://forums.opensuse.org/english/get-technical-help-here/network-internet/455409-11-4-strange-nfs-v4-problem-invisible-files.html

TagsNo tags attached.

Relationships

related to 0006241 resolvedtoracat CentOS-5 See: 0005496: readdir() fails to return all entries of a NFS directory 
related to 0005496 resolvedIssue Tracker CentOS-6 readdir() fails to return all entries of a NFS directory 

Activities

rkollien

rkollien

2013-01-31 11:42

reporter   ~0016368

I just run into a similar problem. Don't know, if it is the same, as i don't know if my old LTS mounts with v4, but with Centos kernel 2.6.18-348 i immediately cannot mount from LTSP-4 clients (a old kernel 2.4.26) to the 5.9 server. A ls command returns emtpy, X11 looking for modules to load fail with "doesn't exist".

If i do a "cat filename" or "more filename", the file is accessed. Only reading the dir seems not to workl.

Reverting to kernel 2.6.18-308.24.1.el5 brings back the old functionality.
Andreas Baumann

Andreas Baumann

2013-01-31 12:05

reporter   ~0016369

Looks Centos 6.2 had the same problem, 6.3 is fine:

http://bugs.centos.org/view.php?id=5496

Maybe this has the same root cause?
toracat

toracat

2013-02-11 19:33

manager   ~0016480

May be related to (or a duplicate of) bug #6241.
toracat

toracat

2013-04-17 12:19

manager   ~0017224

kernel-2.6.18-348.4.1.el5 has been released. Does the problem still exist in this version?
Andreas Baumann

Andreas Baumann

2013-04-17 12:28

reporter   ~0017226

Sadly I replaced Centos 5 on the NAS and can't test it easily at the moment.. :-(
rkollien

rkollien

2013-04-17 12:35

reporter   ~0017227

Will try and report as soon as possible.
Have a development system which currently updates to .4.1 but cannot be rebooted until night (MEST).
rkollien

rkollien

2013-04-18 05:29

reporter   ~0017229

Unfortunately i have to report, that the new kernel didn't change anything. After mounting NFS vol exported from a 5.9 system, a ls (readdir) doesn't show any files. Direct access by (known) name still possible.
toracat

toracat

2013-04-18 15:29

manager   ~0017231

@rkollien

I am still not quite sure if the problem you are seeing is the same as the OP's. Hope Andreas Baumann can test the latest kernel and see if the original issue is resolved.
odimond

odimond

2013-04-18 19:40

reporter   ~0017233

I was seeing the same problem as the OP and kernel-2.6.18-348.4.1.el5 appears to have resolved it. ls on a directory containing a large number of files returns only a partial listing when the NFS server is booted with any previous 5.9 kernel (2.6.18-348 through 2.6.18-348.3.1).

Server: CentOS 5.9 32-bit
Client: CentOS 6.4 32-bit
toracat

toracat

2013-04-18 20:02

manager   ~0017234

@odimond

Thanks for the report. That confirms that the following description in the kernel release note applies to the current bug.

"Previously, the NFSv3 server incorrectly converted 64-bit cookies to
32-bit. Consequently, the cookies became invalid, which affected all file
system operations depending on these cookies, such as the READDIR operation
that is used to read entries from a directory. This led to various
problems, such as exported directories being empty or displayed
incorrectly, or an endless loop of the READDIRPLUS procedure which could
potentially cause a buffer overflow. This update modifies knfsd code so
that 64-bit cookies are now handled correctly and all file system
operations work as expected. (BZ#924087)"

Issue History

Date Modified Username Field Change
2013-01-23 08:24 Andreas Baumann New Issue
2013-01-31 11:42 rkollien Note Added: 0016368
2013-01-31 12:05 Andreas Baumann Note Added: 0016369
2013-02-11 19:32 toracat Relationship added related to 0006241
2013-02-11 19:33 toracat Note Added: 0016480
2013-04-16 20:09 toracat Relationship added related to 0005496
2013-04-17 12:19 toracat Note Added: 0017224
2013-04-17 12:19 toracat Status new => feedback
2013-04-17 12:28 Andreas Baumann Note Added: 0017226
2013-04-17 12:28 Andreas Baumann Status feedback => assigned
2013-04-17 12:35 rkollien Note Added: 0017227
2013-04-18 05:29 rkollien Note Added: 0017229
2013-04-18 15:29 toracat Note Added: 0017231
2013-04-18 19:40 odimond Note Added: 0017233
2013-04-18 20:02 toracat Note Added: 0017234